/*

TinyNetworkRPG²ƪ

Freeware. For non-commercial purpose.

Developed under C++Builder2006.

Copyright(c) 2006. Liu,Jiun-Jiue.

Taiwan ,NCTU.

My homepage:
http://www.cs.nctu.edu.tw/~hank1985/

*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit5.h"                       

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


int sx,sy;
int px,py;
int mapWidth,mapHeight;
int subWidth,subHeight;
int manWidth,manHeight;
bool mouseDown;
float xrot,zrot,yrot;
float xpos,ypos,zpos;

bool WalkOver;


bool pressRight;
bool pressSpace;



int mainroletype;

//---------------------------------------------------------------------------

void TForm1::SetNowImagePage(int pagenum)
{
	NowImagePage=pagenum;
}

void __fastcall TForm1::myMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	myVector mypt;
	mypt = myt->GetOGLPos(X,Y);
	mypt.x=(mypt.x+1.0)/2.0 * (float)  myt->glCanvas()->Width;
	mypt.y=(1.0-mypt.y)/2.0* (float)  myt->glCanvas()->Height;
	myt->glCanvas()->Canvas->Rectangle( mypt.x,mypt.y,mypt.x+10 ,mypt.y+10);
	myt->myUpdate();
}
void myGLRender(MyOpenGLPanel *Owner)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// clear screen and depth buffer
	glLoadIdentity();       // Reset the current modelview matrix
	zpos=-3.2f;
	ypos=-0.2f;
	xpos=0.1f;
//	Form1->Caption ="!";
//	xpos=0.1f;
	glTranslatef(xpos,ypos,zpos);          // Move into the screen 5 units
	glRotatef(xrot,1.0f,0.0f,0.0f);		// Rotate on the X axis
	glRotatef(yrot,0.0f,1.0f,0.0f);		// Rotate on the Y axis
	glRotatef(zrot,0.0f,0.0f,1.0f);		// Rotate on the Z axis
	glBindTexture(GL_TEXTURE_2D, Owner->texture[0]);       // Select our texture
	glBegin(GL_QUADS);
	// Front face
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom left of the texture and quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom right of the texture and quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top right of the texture and quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top left of the texture and quad
	glEnd();
}

void TForm1::LoadCharaImage(int which,int roletype)
{
	int i,j,k;
	myrpg->chara[which].Exist=true;
	myrpg->chara[which].AG_Count=4;
	myrpg->chara[which].Visible=true;
	myrpg->chara[which].X =rand()%12 ;
	myrpg->chara[which].Y =rand()%12+1 ;
	for(i=0;i<4;i++){
		myrpg->chara[which].AniImage[i].MainBmpIndex=0;
		myrpg->chara[which].AniImage[i].Amount = 3;
		myrpg->chara[which].AniImage[i].Interval = 90;
		myrpg->chara[which].AniImage[i].LockAtIndex=1;
		myrpg->chara[which].AniImage[i].PlayingIndex=0;
		for(k=0;k<16;k++){
			myrpg->chara[which].AniImage[k].ImageArrayPtr[i]=&(myrpg->CharaImage[i]);
		}
		for(j=0;j<3;j++){
			if( roletype==0 ){
				myrpg->chara[which].AniImage[i].ImageSourceList[j].X =j+1;//j+1 ;
				myrpg->chara[which].AniImage[i].ImageSourceList[j].Y =i+1;//i+1 ;
			}else if( roletype==1 ){
				myrpg->chara[which].AniImage[i].ImageSourceList[j].X =3+j+1;//j+1 ;
				myrpg->chara[which].AniImage[i].ImageSourceList[j].Y =4+i+1;//i+1 ;
			}else if( roletype==2 ){
				myrpg->chara[which].AniImage[i].ImageSourceList[j].X =9+j+1;//j+1 ;
				myrpg->chara[which].AniImage[i].ImageSourceList[j].Y =i+1;//i+1 ;
			}else if( roletype==3 ){
				myrpg->chara[which].AniImage[i].ImageSourceList[j].X =6+j+1;//j+1 ;
				myrpg->chara[which].AniImage[i].ImageSourceList[j].Y =i+1;//i+1 ;
			}
		}
	}
	myrpg->chara[which].NowPlayIndex =2;
	myrpg->chara[which].FaceDirect =2;
}
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	int i,j,k,s;
	subHeight=24;
	subWidth=24;

	// init OpenGL
	myt=NULL;
	myt=new MyOpenGLPanel( this );
	myt->Left =5;
	myt->Top =140;
	myt->Width =512;
	myt->Height =512;
	myt->Visible =true;
	myt->Parent = this ;
	myt->RenderGLScene = myGLRender ;
	myt->GL_Initialize();
	myt->OnMouseDown = GLPanel_MouseDown;
	myt->OnMouseUp = GLPanel_MouseUp;
	myt->OnMouseMove = GLPanel_MouseMove;
	this->OnKeyDown = GLPanel_KeyDown;
	this->OnKeyUp = GLPanel_KeyUp;	
	this->KeyPreview =true;
	zpos=-5.4f;
	// init
	AnsiString tmpstr;
	myrpg=new MyOnlineRPG( myt );
	//JUعϤ
	myrpg->svX=0;
	myrpg->svY=0;
	myrpg->GridPixelWidth=24;
	myrpg->GridPixelHeight=24;
	for(i=0;i<1;i++){
		tmpstr.sprintf("images\\Map_%d.bmp",i );
		myrpg->GridImage[i].bmpMain->LoadFromFile( tmpstr );
		myrpg->GridImage[i].subWidth =16;
		myrpg->GridImage[i].subHeight =16;
	}


	Image2->Canvas->Draw(0,0,myrpg->GridImage[0].bmpMain);

	for(i=0;i<1;i++){
		tmpstr.sprintf("images\\Object_%d.bmp",i );
		myrpg->ObjectImage[i].bmpMain->LoadFromFile( tmpstr );
		myrpg->ObjectImage[i].subWidth =24;
		myrpg->ObjectImage[i].subHeight =32;
	}


	//JHϮw

	for(i=0;i<1;i++){
		tmpstr.sprintf("images\\Chara_%d.bmp",i );
		myrpg->CharaImage[i].bmpMain->LoadFromFile( tmpstr );
		myrpg->CharaImage[i].subWidth =24;
		myrpg->CharaImage[i].subHeight =32;
	}

	for(i=0;i<1;i++){
		tmpstr.sprintf("images\\number_%d.bmp",i );
		myrpg->OtherImage[i].bmpMain->LoadFromFile( tmpstr );
		myrpg->OtherImage[i].subWidth =39;
		myrpg->OtherImage[i].subHeight =40;
	}

//	for(i=0;i<1;i++){
/*		tmpstr.sprintf("images\\booza_0.bmp");
		myrpg->OtherImage[i].bmpMain->LoadFromFile( tmpstr );
		myrpg->OtherImage[i].subWidth =50;
		myrpg->OtherImage[i].subHeight =50;*/
//	}


	// ]wH
	myrpg->chara[0].Exist=true;

	myrpg->chara[0].AG_Count=4;
	myrpg->chara[0].Visible=true;
	myrpg->chara[0].X =myrpg->chara[0].Y =0;
	for(i=0;i<4;i++){
		myrpg->chara[0].AniImage[i].MainBmpIndex=0;
		myrpg->chara[0].AniImage[i].Amount = 3;
		myrpg->chara[0].AniImage[i].Interval = 80;
		myrpg->chara[0].AniImage[i].LockAtIndex=1;
//		myrpg->chara[0].AniImage[i].PlayingIndex=2;
		for(k=0;k<16;k++){
			myrpg->chara[0].AniImage[k].ImageArrayPtr[i]=&(myrpg->CharaImage[i]);
		}
		for(j=0;j<3;j++){
			myrpg->chara[0].AniImage[i].ImageSourceList[j].X = j+1 ;
			myrpg->chara[0].AniImage[i].ImageSourceList[j].Y = i+1 ;
		}
	}
	myrpg->chara[0].NowPlayIndex =2;
	myrpg->chara[0].FaceDirect =2;
	NowImagePage=0;
	myrpg->chara[0].LockCamera =true;
	//-----------------------
	for(s=21;s<30;s++){
		LoadCharaImage(s,rand()%4);
	}
	//-----------------------

	WalkOver=true;

	//Ja
	ifstream myfile;
	char tmparr[16384];
	int tmplen;
	myfile.open("map\\mapdata.map");
	if( myfile ){
		for(j=0;j<MaxMapH;j++){
			myfile.getline( tmparr , sizeof(tmparr) );
			if( myfile.eof() )
				break;
			char *ptr;
			for( ptr=strtok( tmparr , "," ),i=0 ; ptr!=NULL ; ptr=strtok( NULL,"," ) ){
				myrpg->MapData[i][j].Index = atoi(ptr) ;
				ptr=strtok( NULL,"," );
				myrpg->MapData[i][j].X = atoi(ptr) ;
				ptr=strtok( NULL,"," );
				myrpg->MapData[i][j].Y =atoi(ptr);
				ptr=strtok( NULL,"," );
				myrpg->MapData[i][j].flag =atoi(ptr);
				i++;
			}
		}
	}
	myfile.close() ;

//------
	myrpg->MapData[8][8].objflag=0;
	myrpg->MapData[2][6].objflag=0;
	myrpg->MapData[5][5].objflag=0;	
//	myrpg->MapData[5][1].objflag=0;
	myrpg->obj[0].Exist=true;
	myrpg->obj[0].AG_Count=1;
	myrpg->obj[0].Visible=true;
	myrpg->obj[0].X =myrpg->obj[0].Y =3;
	for(i=0;i<1;i++){
		myrpg->obj[0].AniImage[i].MainBmpIndex=0;
		myrpg->obj[0].AniImage[i].Amount = 3;
		myrpg->obj[0].AniImage[i].Enabled =true;
		myrpg->obj[0].AniImage[i].Interval = 80;
		myrpg->obj[0].AniImage[i].LockAtIndex=1;
//		myrpg->obj[0].AniImage[i].PlayingIndex=2;
		for(k=0;k<16;k++){
			myrpg->obj[0].AniImage[k].ImageArrayPtr[i]=&(myrpg->ObjectImage[i]);
		}
		for(j=0;j<3;j++){
			myrpg->obj[0].AniImage[i].ImageSourceList[j].X = j+1 ;
			myrpg->obj[0].AniImage[i].ImageSourceList[j].Y = i+1 ;
		}
	}
	myrpg->obj[0].NowPlayIndex =0;
	myrpg->MapData[10][8].objflag=1;
	myrpg->MapData[12][2].objflag=1;
	myrpg->MapData[5][4].objflag=1;

	myrpg->obj[1].Exist=true;
	myrpg->obj[1].AG_Count=1;
	myrpg->obj[1].Visible=true;
	myrpg->obj[1].X =myrpg->obj[1].Y =3;
	for(i=0;i<1;i++){
		myrpg->obj[1].AniImage[i].MainBmpIndex=0;
		myrpg->obj[1].AniImage[i].Amount = 3;
		myrpg->obj[1].AniImage[i].Enabled =true;
		myrpg->obj[1].AniImage[i].Interval = 80;
		myrpg->obj[1].AniImage[i].LockAtIndex=1;
//		myrpg->obj[1].AniImage[i].PlayingIndex=2;
		for(k=0;k<16;k++){
			myrpg->obj[1].AniImage[k].ImageArrayPtr[i]=&(myrpg->ObjectImage[i]);
		}
		for(j=0;j<3;j++){
			myrpg->obj[1].AniImage[i].ImageSourceList[j].X = j+1 ;
			myrpg->obj[1].AniImage[i].ImageSourceList[j].Y = 5 ;
		}
	}
	myrpg->obj[1].NowPlayIndex =0;

	Width=581;




}

//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
	int i;

	if( myt!=NULL )
		delete myt;

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
//	Image1->Picture->Assign( bmpArray[((TListBox *)Sender)->ItemIndex] );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GLPanel_MouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	if( Edit1->Text != "editmode" ) return;
	if( Button==mbLeft ){
		int gridx,gridy;
		myVector mypt;
		mypt = myt->GetOGLPos(X,Y);
		mypt.x=(mypt.x+1.0)/2.0 * (float)  myt->glCanvas()->Width;
		mypt.y=(1.0-mypt.y)/2.0* (float)  myt->glCanvas()->Height;
		gridx=myrpg->svX  + ((int)mypt.x)/subWidth;
		gridy=myrpg->svY + ((int)mypt.y)/subHeight;
		if( gridx>=0 && gridx<400 && gridy>=0 && gridy<400 ){
			myrpg->MapData[gridx][gridy].Index = NowImagePage;
			myrpg->MapData[gridx][gridy].X = NowImageX;
			myrpg->MapData[gridx][gridy].Y = NowImageY;
			if( WalkOver )
				myrpg->MapData[gridx][gridy].flag = 0;
			else
				myrpg->MapData[gridx][gridy].flag = 1;


			//myMap[gridx][gridy]=(int)'A' + ListBox1->ItemIndex ;
		}
//		MapForceRedraw();
		mouseDown=true;
	}
	if( Edit1->Visible ==true ){
		Edit1->Visible =false;
		SpeedButton8->Visible =true;
		Form1->SetFocus();
	}
}
//---------------------------------------------------------------------------
/*void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{
	if( mapBmp!=NULL )
		PaintBox1->Canvas->Draw( 0,0,mapBmp );
}*/
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
	// for debug
	Label1->Caption = AnsiString(ScrollBar1->Position) + "," + AnsiString(ScrollBar2->Position);

	if( ScrollBar2->Position +10 >= 400 ){
		// Need range 0~399
		return;
	}else{
		sy=ScrollBar2->Position ;
//		MapForceRedraw();


	}

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
	// for debug
	Label1->Caption = AnsiString(ScrollBar1->Position) + "," + AnsiString(ScrollBar2->Position);

	if( ScrollBar1->Position +10 >= 400 ){
		// Need range 0~399
		return;
	}else{
		sx=ScrollBar1->Position ;
//		MapForceRedraw();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GLPanel_MouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	if( mouseDown ){
   		if( Edit1->Text != "editmode" ) return;
		int gridx,gridy;
		myVector mypt;
		mypt = myt->GetOGLPos(X,Y);
		mypt.x=(mypt.x+1.0)/2.0 * (float)  myt->glCanvas()->Width;
		mypt.y=(1.0-mypt.y)/2.0* (float)  myt->glCanvas()->Height;
		gridx=myrpg->svX + ((int)mypt.x)/subWidth;
		gridy=myrpg->svY+ ((int)mypt.y)/subHeight;
		if( gridx>=0 && gridx<400 && gridy>=0 && gridy<400 ){
			myrpg->MapData[gridx][gridy].Index = NowImagePage;
			myrpg->MapData[gridx][gridy].X = NowImageX;
			myrpg->MapData[gridx][gridy].Y = NowImageY;
			if( WalkOver )
				myrpg->MapData[gridx][gridy].flag = 0;
			else
				myrpg->MapData[gridx][gridy].flag = 1;			
 //			myMap[gridx][gridy]=(int)'A' + ListBox1->ItemIndex ;
		}
	 //	MapForceRedraw();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GLPanel_MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	mouseDown=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IdleLoop(TObject*, bool& done)
{
	 static prevTickCount,nowTickCount,mySec,i,k,z;
	 done = false;


//	 myt->GL_Paint();
			//Caption=AnsiString( mySec++ );
	 
//		 myrpg->RedrawMapImage();
	 nowTickCount= GetTickCount() ;

	 if( nowTickCount-prevTickCount >=70 ){
//	 if( myt->glCanvas()->Width !=512 || myt->glCanvas()->Height !=512 ){
//		ShowMessage("!");
//	 }
//		 Caption=AnsiString( mySec++ );
		 myrpg->RedrawMapImage();
		 myt->myUpdate();
//		 myt->GL_Paint();
		 prevTickCount= GetTickCount() ;

	 }



//int i;
//for(i=1;i<100;i++);
//	myt->myUpdate();

	//@wn@!!(_h|cpu load 99%, D]!! )
	myt->GL_Paint();
	done=true;
}

void __fastcall TForm1::GLPanel_KeyUp(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if( Key==VK_RIGHT )
		pressRight=false;
	else if( Key==VK_SPACE )
		pressSpace=false;
}
void __fastcall TForm1::GLPanel_KeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	int i;
	if( myrpg->chara[0].ActionQueue.size()>0 )
		return;

if( Key==VK_RIGHT )
	pressRight=true;
else if( Key==VK_SPACE )
	pressSpace=true;

	if( Key==VK_RIGHT ){
		myrpg->chara[0].Walk(1);
	}else if( Key==VK_LEFT ){
		myrpg->chara[0].Walk(3);
	}else if( Key==VK_UP ){
		myrpg->chara[0].Walk(0);
	}else if( Key==VK_DOWN ){
		myrpg->chara[0].Walk(2);
	}

	if( pressSpace ){
		if( myrpg->chara[0].FaceDirect ==1 ){
			myrpg->MapData[myrpg->chara[0].X+1][myrpg->chara[0].Y].objflag = 0;
		}else if( myrpg->chara[0].FaceDirect ==3){
			myrpg->MapData[myrpg->chara[0].X-1][myrpg->chara[0].Y].objflag = 0;
		}else if( myrpg->chara[0].FaceDirect ==0 ){
			myrpg->MapData[myrpg->chara[0].X][myrpg->chara[0].Y-1].objflag = 0;
		}else if( myrpg->chara[0].FaceDirect ==2 ){
			myrpg->MapData[myrpg->chara[0].X][myrpg->chara[0].Y+1].objflag = 0;
		}
//		myrpg->chara[0].JumpUp();
//		for(i=0;i<
	}
}



void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
//	ListBox1->Visible =false;
/*	Button1->Visible =false;
	ScrollBar1->Visible =false;
	ScrollBar2->Visible =false;
	ShowMessage("NCTU.rpg.map.editor");*/
		int i,j;
	ofstream myfile;
	char mytemp[80];
	myfile.open("map\\mapdata.map");
	if( myfile ){
		for(j=0;j<MaxMapH;j++){
			for(i=0;i<MaxMapW;i++){
				if( !(i==0&&j==0) )
					myfile << "," ;
				sprintf(mytemp,"%d,%d,%d,%d",	myrpg->MapData[i][j].Index ,
								myrpg->MapData[i][j].X  ,
								myrpg->MapData[i][j].Y,
								myrpg->MapData[i][j].flag );
				myfile << mytemp ;

			}
			myfile << "\n" ; //Oo_
		}
		myfile << "\n" ;
		ShowMessage("xsɮק!");
	}else ShowMessage("ɮ׵LkgJ!");
	myfile.close();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
	xrot+=-20.0;
	ypos-=0.5;
}
//---------------------------------------------------------------------------







void __fastcall TForm1::Image2MouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	int dx,dy;
	dx=X - X%16;
	dy=Y - Y%16;
	Shape1->Left = Image2->Left + dx;
	Shape1->Top = Image2->Top + dy;
	Shape1->Width =16;
	Shape1->Height =16;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
//	Image2->Repaint();
	myrpg->Chara_GoTo(0,4,2); 
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Image2MouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
//	ShowMessage("!");
	int dx,dy;
	Graphics::TBitmap *tmpbmp=new Graphics::TBitmap;
	dx=X - X%16;
	dy=Y - Y%16;
//	ShowMessage( X/16);
	NowImageX=dx/16+1;
	NowImageY=dy/16+1;
	myrpg->GridImage[NowImagePage].GetSubImage(dx/16+1,dy/16+1,tmpbmp);
	Image1->Canvas->Draw(0,0,tmpbmp);
	Image1->Repaint();
//	ShowMessage("!");
	if( tmpbmp!=NULL ) delete tmpbmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Shape1MouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
//	Shape1->Visible =false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Shape1MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	Image2MouseDown(Image2,Button,Shift, Shape1->Left -Image2->Left +X , Shape1->Top -Image2->Top +Y );
}
//---------------------------------------------------------------------------




void __fastcall TForm1::Button2Click(TObject *Sender)
{
	myrpg->chara[0].Walk(2);    	
}
//---------------------------------------------------------------------------









void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	static int x;
	static bool working;
	int i;
	if( working ) return;
	working=true;
	x++;
	for(i=21;i<30;i++){
	if( myrpg->chara[i].ActionQueue.size()>2 ) continue;
	if( x<=6)
		myrpg->chara[i].Walk(rand()%4);
	else if( x<=10 )
		myrpg->chara[i].Walk(rand()%4);
	else if( x%3!=1 )
		myrpg->chara[i].Walk(rand()%3);
	else
		myrpg->chara[i].Walk(rand()%4);
	}
	x=x%18;
	if( x==0 ) srand(time(NULL));
	working=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
//TimerC2Ұʤ@
	static bool timerworking,done=true;
	if( timerworking ) return;
	timerworking=true;
	if( done )
		IdleLoop(NULL,done);
	timerworking=false;
}
//---------------------------------------------------------------------------






void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
	WalkOver=! WalkOver ;
	if( WalkOver )
		SpeedButton6->Caption ="iqL";
	else
		SpeedButton6->Caption ="LkqL";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
	//timerC2Ұʤ@
	static bool timerworking,done;
	static int timesCount;
	static int oldcx,oldcy;
	int i;
	char mybuf[30];
	if( timerworking ) return;
	timerworking=true;

//Mchat queueª2
	if( myrpg->ChatMsgQueue.size()>32 ){
		for(i=0;i<8;i++){
			myrpg->ChatMsgQueue.erase( myrpg->ChatMsgQueue.begin() );
		}
	}else if( myrpg->ChatMsgQueue.size()>12 ){
		for(i=0;i<4;i++){
			myrpg->ChatMsgQueue.erase( myrpg->ChatMsgQueue.begin() );
		}
	}else if( myrpg->ChatMsgQueue.size()>8 ){
		for(i=0;i<2;i++){
			myrpg->ChatMsgQueue.erase( myrpg->ChatMsgQueue.begin() );
		}
	}
/*	if( timesCount==0 ){
		//CQǰe
		SendDataU("#gettime");
		SendDataU("#howmanypeople");
	}*/
	timesCount++;
	timesCount = timesCount % 8;
	timerworking=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormShow(TObject *Sender)
{
  //	Form2->Show();
//	Timer1->Enabled =true;
//	Timer2->Enabled =true;

}
//---------------------------------------------------------------------------








void __fastcall TForm1::SpeedButton8MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Edit1->Visible =true;
	SpeedButton8->Visible =false;
	Edit1->SetFocus(); 	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	Edit1->Visible =false;
	SpeedButton8->Visible =true;
	Form1->SetFocus(); 	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if( Key==13 || Key==VK_RETURN ){
		char textbuf[80];
		sprintf( textbuf , "@chat,%s" , Edit1->Text.c_str() );

		Edit1->Visible =false;
		SpeedButton8->Visible=true;
		Form1->SetFocus();
		char mytmp[128];
		sprintf(mytmp,"%s : %s",myrpg->chara[0].name,Edit1->Text.c_str() );
		myrpg->ChatMsgQueue.push_back( AnsiString(mytmp) );
	}
}
//---------------------------------------------------------------------------








void __fastcall TForm1::Image3Click(TObject *Sender)
{
	if( Edit1->Text == "editmode" ){
		if( Width<590 ){
			Width=988;
		}else
			Width=581;
	}else{
    	ShowMessage("qj BCe ]p");
	}
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Image4DblClick(TObject *Sender)
{
	Form2->Close();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer4Timer(TObject *Sender)
{
	Form2->Close();
}
//---------------------------------------------------------------------------















void __fastcall TForm1::ToolButton6Click(TObject *Sender)
{
	Form5->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton5Click(TObject *Sender)
{
	Form2->Close();
}
//---------------------------------------------------------------------------










void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	Form2->Close(); 

}
//---------------------------------------------------------------------------

